/*
 * Copyright 2011 Hanson Robokind LLC.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * VideoControlPanel.java
 *
 * Created on Nov 18, 2011, 3:11:44 AM
 */
package org.robokind.ui.swing.vision;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.Session;
import org.apache.qpid.client.AMQAnyDestination;
import org.apache.qpid.client.AMQConnectionFactory;
import org.apache.qpid.client.AMQQueue;
import org.robokind.api.messaging.RemoteService;
import org.robokind.api.vision.ImageRegionService;
import org.robokind.api.vision.ImageService;
import org.robokind.avrogen.vision.CameraConfig;
import org.robokind.avrogen.vision.FaceDetectConfig;
import org.robokind.impl.messaging.RemoteServiceFacade;
import org.robokind.impl.vision.JMSImageReceiver;
import org.robokind.impl.vision.JMSImageRegionListReceiver;

/**
 *
 * @author Matthew Stevenson <www.robokind.org>
 */
public class VideoControlPanel extends javax.swing.JPanel {
    private VideoPanel myVideoPanel;
    /** Creates new form VideoControlPanel */
    public VideoControlPanel() {
        initComponents();
    }
    
    public void setVideoPanel(VideoPanel panel){
        myVideoPanel = panel;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btnConnect = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        myVideoControl = new org.robokind.ui.swing.common.PlayControlPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        myFaceDetectControl = new org.robokind.ui.swing.common.PlayControlPanel();
        jLabel3 = new javax.swing.JLabel();

        btnConnect.setText("Connect");
        btnConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConnectActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel1.setText("Video");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(myVideoControl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(myVideoControl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel3.setText("Face Detection");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(myFaceDetectControl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(myFaceDetectControl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(btnConnect)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(btnConnect, javax.swing.GroupLayout.DEFAULT_SIZE, 37, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnConnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConnectActionPerformed
        String vid = "vision.VideoTopic1; {create: always, node: {type: topic}}";
        String fd = "vision.FaceTopic1; {create: always, node: {type: topic}}";
        String con = "amqp://admin:admin@clientid/test?brokerlist='tcp://localhost:5672'";
        try{
            ConnectionFactory cf = new AMQConnectionFactory(con);
            Connection connection = cf.createConnection();
            Session session = connection.createSession(false, Session.CLIENT_ACKNOWLEDGE);
            connection.start();
            connectVideoStream(session, vid, fd);
            RemoteService videoService = cameraControlFacade(session);
            RemoteService faceService = faceDetectControlFacade(session);
            myVideoControl.setPlayable(videoService);
            myFaceDetectControl.setPlayable(faceService);
        }catch(Throwable t){
            t.printStackTrace();
        }
    }//GEN-LAST:event_btnConnectActionPerformed

    
    private RemoteService<CameraConfig> cameraControlFacade(Session session) throws Exception {
        Destination cmdDest = new AMQQueue("vision.CamCmdQueue1; {create: always, node: {type: queue}}");
        Destination errDest = new AMQQueue("vision.CamErrQueue1; {create: always, node: {type: queue}}");
        return new RemoteServiceFacade(CameraConfig.class, 
                new CameraConfig(), session, cmdDest, errDest);
    }
    
    private RemoteService<FaceDetectConfig> faceDetectControlFacade(Session session) throws Exception {
        Destination cmdDest = new AMQQueue("vision.FaceCmdQueue1; {create: always, node: {type: queue}}");
        Destination errDest = new AMQQueue("vision.FaceErrQueue1; {create: always, node: {type: queue}}");
        return new RemoteServiceFacade(FaceDetectConfig.class, 
                new FaceDetectConfig(), session, cmdDest, errDest);
    }
    
    public void connectVideoStream(Session session, String imgQueue, String rgnsQueue) throws Throwable{
        Destination imgDest = new AMQAnyDestination(imgQueue);
        Destination rgnDest = new AMQAnyDestination(rgnsQueue);
        ImageService imgs = new JMSImageReceiver(session, imgDest);
        imgs.addMessageListener(myVideoPanel.getImageEventListener());
        imgs.start();
        ImageRegionService rgns = new JMSImageRegionListReceiver(session, rgnDest);
        rgns.addMessageListener(myVideoPanel.getImageRegionListListener());
        rgns.start();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnConnect;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private org.robokind.ui.swing.common.PlayControlPanel myFaceDetectControl;
    private org.robokind.ui.swing.common.PlayControlPanel myVideoControl;
    // End of variables declaration//GEN-END:variables
}
